import { ObjectUIServiceBase } from '@objects-view/object-ui-service-base';
import { ConfigService } from '@shared/config/config.service';
import { DateFormatterPipe } from '@shared/ui/common/pipes/date-formatter.pipe';
import { IPermissionsModel } from '@fleio-api/base-model/IPermissionsModel';
import { IIcon } from '@shared/ui/common/interfaces/icon';
import { IObjectStatus } from '@objects-view/interfaces/object-status';
import { ITitle } from '@objects-view/interfaces/card-data/card-title';
import { IAction } from '@objects-view/interfaces/actions/action';
import { ApiCallAction, CallType } from '@objects-view/actions/api-call-action';
import { CallbackAction } from '@objects-view/actions/callback-action';
import { IDataField } from '@objects-view/interfaces/card-data/data-field';
import { IDetailsTab } from '@objects-view/interfaces/details/details-tab';
import { IFlavorGroupModel } from '@fleio-api/openstack/model/flavor-group.model';
import { Router } from '@angular/router';
import { FlavorGroupsApiService } from '@fleio-api/openstack/flavor-group/flavor-groups-api.service';
import { RouterLinkAction } from '@objects-view/actions/router-link-action';
import { FlavorGroupEditFormComponent } from './tabs/flavor-group-edit-form/flavor-group-edit-form.component';
import { FlavorGroupDetailsOverviewComponent } from './tabs/flavor-group-details-overview/flavor-group-details-overview.component';
import { EntityAuditLogComponent } from '../../common-components/entity-audit-log/entity-audit-log.component';

export class FlavorGroupUiService extends ObjectUIServiceBase<IFlavorGroupModel> {
  private readonly router: Router;
  private readonly config: ConfigService;
  private readonly flavorGroupsApiService: FlavorGroupsApiService;
  private readonly datePipe: DateFormatterPipe;

  constructor(
    flavorGroupModel: IFlavorGroupModel, permissions: IPermissionsModel, state: string,
    router: Router, config: ConfigService, flavorGroupsApiService: FlavorGroupsApiService,
  ) {
    super(flavorGroupModel, permissions, state);
    this.router = router;
    this.config = config;
    this.flavorGroupsApiService = flavorGroupsApiService;
    this.datePipe = new DateFormatterPipe(this.config);
  }

  getIcon(): IIcon {
    return null;
  }

  getStatus(): IObjectStatus {
    return null;
  }

  getTitle(): ITitle {
    switch (this.state) {
      case 'edit':
        return {
          text: $localize`Edit flavor group ${this.object.name}`,
        };

      case 'create':
        return {
          text: $localize`Create new flavor group`,
        };

      case 'details':
        return {
          text: `${this.object.name}`,
          subText: $localize`Created at ${this.datePipe.toDateTime(this.object.created_at)}`,
        };

      default:
        return {
          text: `${this.object.name}`,
        };
    }
  }

  getActions(): IAction[] {
    const actions: IAction[] = [];

    actions.push(new RouterLinkAction({
        icon: {name: 'edit', class: 'fl-icons'},
        name: $localize`Edit`,
        tooltip: $localize`Edit flavor group`,
        routerUrl: this.config.getPanelUrl(`openstack/flavor-groups/${this.object.id}/edit`),
        router: this.router,
      }
    ));

    const deleteAction = new ApiCallAction(
      {
        object: this.object,
        icon: {name: 'delete'},
        tooltip: $localize`Delete flavor group`,
        name: $localize`Delete`,
        confirmOptions: {
          confirm: true,
          title: $localize`Delete flavor group`,
          message: $localize`Are you sure you want to delete flavor group ${this.object.name}?`,
        },
        successMessage: $localize`Flavor group deleted`,
        errorMessage: $localize`Failed to delete flavor group, check logs for details`,
        apiService: this.flavorGroupsApiService,
        callType: CallType.Delete,
        refreshAfterExecute: false,
        redirectAfterExecute: true,
        redirectUrl: this.config.getPanelUrl('openstack/flavor-groups'),
      }
    );

    actions.push(deleteAction);

    return actions;
  }

  getDetailsActions(): IAction[] {
    const actions = [];

    switch (this.state) {
      case 'create':
        actions.push(new RouterLinkAction({
            name: $localize`Cancel`,
            routerUrl: this.config.getPrevUrl(`openstack/flavor-groups`),
            router: this.router,
          }
        ));
        actions.push(new CallbackAction({name: $localize`Create`}));
        break;
      case 'edit':
        actions.push(new RouterLinkAction({
            name: $localize`Cancel`,
            routerUrl: this.config.getPrevUrl(`openstack/flavor-groups`),
            router: this.router,
          }
        ));
        actions.push(new CallbackAction({name: $localize`Save`}));
        break;
      default:
        break;
    }

    return actions;
  }

  getDetailsLink(): string {
    return this.config.getPanelUrl(`openstack/flavor-groups/${this.object.id}`);
  }

  getCardFields(): IDataField[] {
    const fields = [
      {value: $localize`${this.object.flavor_count} flavors in this group`},
      {name: $localize`Created at`, value: this.datePipe.toDateTime(this.object.created_at)},
      {name: $localize`Description`, value: this.object.description || $localize`n/a`},
    ];

    return fields;
  }

  getTabs(): IDetailsTab[] {
    switch (this.state) {
      case 'create':
        return [
          {
            tabName: $localize`Create`,
            tabIdentifier: 'create',
            component: FlavorGroupEditFormComponent,
          },
        ];
      case 'details':
        return [
          {
            tabName: $localize`Overview`,
            tabIdentifier: 'overview',
            component: FlavorGroupDetailsOverviewComponent,
          },
          {
            tabName: $localize`Audit log`,
            tabIdentifier: 'audit-log',
            component: EntityAuditLogComponent,
            featureName: 'utils.activitylog',
            data: {
              entity_type: 'flavor_group'
            }
          }
        ];
      case 'edit':
        return [
          {
            tabName: $localize`Edit`,
            tabIdentifier: 'edit',
            component: FlavorGroupEditFormComponent,
          },
        ];
    }
  }

  getCardTags(): string[] {
    const tags = [];
    return tags;
  }
}
